Page MenuHomeFreeBSD

lang/beignet: update to 1.3.1.234 (snapshot) and switch to LLVM 4.0 by default
ClosedPublic

Authored by jbeich on Jun 27 2017, 8:00 AM.

Details

Summary

OpenCL on FreeBSD is unusable if we're not proactive in backporting a regression fix or newer llvm support from upstream. Given no one cared for months let's use a snapshot to avoid disaster on the next update.

Due to rP435144 fallout this is planned for MFH to 2017Q2 and 2017Q3

Test Plan
  • default options build fine on 10.3 i386/amd64, 11.0 i386/amd64, 12.0 amd64
  • FP64=on builds fine on 10.3 i386/amd64, 11.0 i386/amd64, 12.0 amd64
  • OCL20=off builds fine on 10.3 amd64, 11.0 amd64, 12.0 amd64
  • TEST=on builds fine on 10.3 i386/amd64, 11.0 i386/amd64, 12.0 amd64
  • OpenCL 2.0 runtime with drm-next@1f8dbbb2ab25 merged with rS323707 on Intel HD530 (Skylake GT2) works fine
  • OpenCL 1.2 runtime (default on i386) works fine as well

Diff Detail

Repository
rP FreeBSD ports repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

jbeich created this revision.Jun 27 2017, 8:00 AM
jbeich edited the summary of this revision. (Show Details)Jun 27 2017, 8:01 AM
jbeich set the repository for this revision to rP FreeBSD ports repository.

Maintainer timeout reached 3 days ago.

jbeich updated this revision to Diff 30803.Jul 14 2017, 11:08 PM
jbeich retitled this revision from lang/beignet: update to 1.3.1.205 (snapshot) and switch to LLVM 4.0 by default to lang/beignet: update to 1.3.1.218 (snapshot) and switch to LLVM 4.0 by default.
jbeich edited the summary of this revision. (Show Details)
jbeich edited the test plan for this revision. (Show Details)
  • New snapshot
  • Improved commit messages
jbeich set the repository for this revision to rP FreeBSD ports repository.Jul 14 2017, 11:11 PM
rezny added a subscriber: rezny.Jul 15 2017, 8:38 AM

Using a snapshot is a better solution than trying to backport support for LLVM 4.0 while we await the release of beignet 1.4.

lang/beignet/files/patch-backend_src_backend_gen__insn__selection__optimize.cpp
30 ↗(On Diff #30803)

This change looks incorrect. abs() should not just be removed to avoid the error. Instead, cast as necessary to get the correct abs(int).

37 ↗(On Diff #30803)

Same as above

Using a snapshot is a better solution than trying to backport support for LLVM 4.0 while we await the release of beignet 1.4.

Maybe but someone reported a regression.

lang/beignet/files/patch-backend_src_backend_gen__insn__selection__optimize.cpp
30 ↗(On Diff #30803)

No[1][2] but upstream finally fixed it.

jbeich updated this revision to Diff 30991.Jul 20 2017, 5:52 AM
jbeich edited the test plan for this revision. (Show Details)
  • Add an option to disable OpenCL 2.0 on amd64 from bug 217771. OpenCL apps fail inside i386 jail on amd64 probably due to missing compatibility for DRM ioctls (at least on drm-next), so disabling OpenCL 2.0 on amd64 maybe the only way to provide an imitation of testing on i386. Besides, OpenCL 2.0 is still unstable even on amd64.
jbeich retitled this revision from lang/beignet: update to 1.3.1.218 (snapshot) and switch to LLVM 4.0 by default to lang/beignet: update to 1.3.1.221 (snapshot) and switch to LLVM 4.0 by default.Jul 20 2017, 5:52 AM
jbeich set the repository for this revision to rP FreeBSD ports repository.
jbeich edited the summary of this revision. (Show Details)Jul 20 2017, 5:55 AM
This comment was removed by jbeich.
jbeich updated this revision to Diff 32440.EditedAug 28 2017, 12:40 PM
jbeich retitled this revision from lang/beignet: update to 1.3.1.221 (snapshot) and switch to LLVM 4.0 by default to lang/beignet: update to 1.3.1.227 (snapshot) and switch to LLVM 4.0 by default.
jbeich edited the test plan for this revision. (Show Details)
  • New snapshot
  • Reported drm-next bug blocking proper QA inside i386 jail
jbeich set the repository for this revision to rP FreeBSD ports repository.Aug 28 2017, 12:44 PM
jbeich updated this revision to Diff 33269.Sep 21 2017, 4:29 PM
jbeich retitled this revision from lang/beignet: update to 1.3.1.227 (snapshot) and switch to LLVM 4.0 by default to lang/beignet: update to 1.3.1.234 (snapshot) and switch to LLVM 4.0 by default.
jbeich edited the test plan for this revision. (Show Details)

New snapshot. Building against devel/llvm50 via MESA_LLVM_VER=50 is now supported.

jbeich set the repository for this revision to rP FreeBSD ports repository.Sep 21 2017, 4:29 PM
This revision was automatically updated to reflect the committed changes.